Index: /trunk/source/Lib/TLibDecoder/TDecTop.cpp
===================================================================
--- /trunk/source/Lib/TLibDecoder/TDecTop.cpp	(revision 1355)
+++ /trunk/source/Lib/TLibDecoder/TDecTop.cpp	(revision 1356)
@@ -3109,18 +3124,18 @@
   const std::vector<Int>& pocLtFoll            = decRps->m_pocLtFoll;
 
-  const Int numPocStCurrBefore                 = decRps->m_numPocStCurrBefore; 
+  const Int numPocStCurrBefore                 = decRps->m_numPocStCurrBefore;
   const Int numPocStCurrAfter                  = decRps->m_numPocStCurrAfter;
   const Int numPocStFoll                       = decRps->m_numPocStFoll;
   const Int numPocLtCurr                       = decRps->m_numPocLtCurr;
-  const Int numPocLtFoll                       = decRps->m_numPocLtFoll;   
-
-  Int nuhLayerId = m_pcPic-> getLayerId(); 
+  const Int numPocLtFoll                       = decRps->m_numPocLtFoll;
+
+  Int nuhLayerId = m_pcPic-> getLayerId();
   for ( Int i = 0 ; i <= numPocStCurrBefore - 1; i++ )
   {
     if ( refPicSetStCurrBefore[ i ] == NULL )
     {
-      //-  For each RefPicSetStCurrBefore[ i ], with i in the range of 0 to NumPocStCurrBefore - 1, inclusive, that is 
+      //-  For each RefPicSetStCurrBefore[ i ], with i in the range of 0 to NumPocStCurrBefore - 1, inclusive, that is
       //  equal to "no reference picture", a picture is generated as specified in clause 8.3.3.2 and the following applies:
-      TComPic* genPic = x8332GenOfOneUnavailPic( false );  
+      TComPic* genPic = x8332GenOfOneUnavailPic( false );
 
       //-  The value of PicOrderCntVal for the generated picture is set equal to PocStCurrBefore[ i ].
@@ -3128,5 +3143,5 @@
 
       //  -  The value of PicOutputFlag for the generated picture is set equal to 0.
-      genPic->setPicOutputFlag( false ); 
+      genPic->setPicOutputFlag( false );
 
       //  -  The generated picture is marked as "used for short-term reference".
@@ -3137,8 +3152,8 @@
 
       //  -  The value of nuh_layer_id for the generated picture is set equal to nuh_layer_id.
-      genPic->setLayerId( nuhLayerId ); 
+      genPic->setLayerId( nuhLayerId );
 
       // Insert to DPB
-      m_dpb->addNewPic( genPic ); 
+      m_dpb->addNewPic( genPic );
     }
   }
@@ -3148,7 +3163,7 @@
     if ( refPicSetStCurrAfter[ i ] == NULL )
     {
-      //  -  For each RefPicSetStCurrAfter[ i ], with i in the range of 0 to NumPocStCurrAfter - 1, inclusive, that is equal 
+      //  -  For each RefPicSetStCurrAfter[ i ], with i in the range of 0 to NumPocStCurrAfter - 1, inclusive, that is equal
       //     to "no reference picture", a picture is generated as specified in clause 8.3.3.2 and the following applies:
-      TComPic* genPic = x8332GenOfOneUnavailPic( false );  
+      TComPic* genPic = x8332GenOfOneUnavailPic( false );
 
       //  -  The value of PicOrderCntVal for the generated picture is set equal to PocStCurrAfter[ i ].
@@ -3156,5 +3171,5 @@
 
       //  -  The value of PicOutputFlag for the generated picture is set equal to 0.
-      genPic->setPicOutputFlag( false ); 
+      genPic->setPicOutputFlag( false );
 
       //  -  The generated picture is marked as "used for short-term reference".
@@ -3165,8 +3180,8 @@
 
       //  -  The value of nuh_layer_id for the generated picture is set equal to nuh_layer_id.
-      genPic->setLayerId( nuhLayerId ); 
+      genPic->setLayerId( nuhLayerId );
 
       // Insert to DPB
-      m_dpb->addNewPic( genPic ); 
+      m_dpb->addNewPic( genPic );
 
     }
@@ -3177,7 +3192,7 @@
     if ( refPicSetStFoll[ i ] == NULL )
     {
-      //  -  For each RefPicSetStFoll[ i ], with i in the range of 0 to NumPocStFoll - 1, inclusive, that is equal to "no 
+      //  -  For each RefPicSetStFoll[ i ], with i in the range of 0 to NumPocStFoll - 1, inclusive, that is equal to "no
       //     reference picture", a picture is generated as specified in clause 8.3.3.2 and the following applies:
-      TComPic* genPic = x8332GenOfOneUnavailPic( false );  
+      TComPic* genPic = x8332GenOfOneUnavailPic( false );
 
       //  -  The value of PicOrderCntVal for the generated picture is set equal to PocStFoll[ i ].
@@ -3185,5 +3200,5 @@
 
       //  -  The value of PicOutputFlag for the generated picture is set equal to 0.
-      genPic->setPicOutputFlag( false ); 
+      genPic->setPicOutputFlag( false );
 
       //  -  The generated picture is marked as "used for short-term reference".
@@ -3194,29 +3209,29 @@
 
       //  -  The value of nuh_layer_id for the generated picture is set equal to nuh_layer_id.
-      genPic->setLayerId( nuhLayerId ); 
+      genPic->setLayerId( nuhLayerId );
 
       // Insert to DPB
-      m_dpb->addNewPic( genPic ); 
-    }
-  }
-
-  Int maxPicOrderCntLsb = m_pcPic->getSlice(0)->getSPS()->getMaxPicOrderCntLsb();  
+      m_dpb->addNewPic( genPic );
+    }
+  }
+
+  Int maxPicOrderCntLsb = m_pcPic->getSlice(0)->getSPS()->getMaxPicOrderCntLsb();
   for ( Int i = 0 ; i <= numPocLtCurr - 1; i++ )
   {
     if ( refPicSetLtCurr[ i ] == NULL )
     {
-      //  -  For each RefPicSetLtCurr[ i ], with i in the range of 0 to NumPocLtCurr - 1, inclusive, that is equal to "no 
+      //  -  For each RefPicSetLtCurr[ i ], with i in the range of 0 to NumPocLtCurr - 1, inclusive, that is equal to "no
       //     reference picture", a picture is generated as specified in clause 8.3.3.2 and the following applies:
-      TComPic* genPic = x8332GenOfOneUnavailPic( false );  
+      TComPic* genPic = x8332GenOfOneUnavailPic( false );
 
       //  -  The value of PicOrderCntVal for the generated picture is set equal to PocLtCurr[ i ].
       genPic->getSlice(0)->setPOC( pocLtCurr[ i ] );
 
-      //  -  The value of slice_pic_order_cnt_lsb for the generated picture is inferred to be equal to ( PocLtCurr[ i ] & ( 
+      //  -  The value of slice_pic_order_cnt_lsb for the generated picture is inferred to be equal to ( PocLtCurr[ i ] & (
       //     MaxPicOrderCntLsb - 1 ) ).
-      genPic->getSlice(0)->setSlicePicOrderCntLsb( ( pocLtCurr[ i ] & ( maxPicOrderCntLsb - 1 ) ) ); 
+      genPic->getSlice(0)->setSlicePicOrderCntLsb( ( pocLtCurr[ i ] & ( maxPicOrderCntLsb - 1 ) ) );
 
       //  -  The value of PicOutputFlag for the generated picture is set equal to 0.
-      genPic->setPicOutputFlag( false ); 
+      genPic->setPicOutputFlag( false );
 
       //  -  The generated picture is marked as "used for long-term reference".
@@ -3227,8 +3242,8 @@
 
       //  -  The value of nuh_layer_id for the generated picture is set equal to nuh_layer_id.
-      genPic->setLayerId( nuhLayerId ); 
+      genPic->setLayerId( nuhLayerId );
 
       // Insert to DPB
-      m_dpb->addNewPic( genPic ); 
+      m_dpb->addNewPic( genPic );
     }
   }
@@ -3238,17 +3253,17 @@
     if ( refPicSetLtFoll[ i ] == NULL )
     {
-      //  -  For each RefPicSetLtFoll[ i ], with i in the range of 0 to NumPocLtFoll - 1, inclusive, that is equal to "no 
+      //  -  For each RefPicSetLtFoll[ i ], with i in the range of 0 to NumPocLtFoll - 1, inclusive, that is equal to "no
       //     reference picture", a picture is generated as specified in clause 8.3.3.2 and the following applies:
-      TComPic* genPic = x8332GenOfOneUnavailPic( false );  
+      TComPic* genPic = x8332GenOfOneUnavailPic( false );
 
       //  -  The value of PicOrderCntVal for the generated picture is set equal to PocLtFoll[ i ].
       genPic->getSlice(0)->setPOC( pocLtFoll[ i ] );
 
-      //  -  The value of slice_pic_order_cnt_lsb for the generated picture is inferred to be equal to ( PocLtCurr[ i ] & ( 
+      //  -  The value of slice_pic_order_cnt_lsb for the generated picture is inferred to be equal to ( PocLtCurr[ i ] & (
       //     MaxPicOrderCntLsb - 1 ) ).
-      genPic->getSlice(0)->setSlicePicOrderCntLsb( ( pocLtCurr[ i ] & ( maxPicOrderCntLsb - 1 ) ) ); 
+      genPic->getSlice(0)->setSlicePicOrderCntLsb( ( pocLtCurr[ i ] & ( maxPicOrderCntLsb - 1 ) ) );
 
       //  -  The value of PicOutputFlag for the generated picture is set equal to 0.
-      genPic->setPicOutputFlag( false ); 
+      genPic->setPicOutputFlag( false );
 
       //  -  The generated picture is marked as "used for long-term reference".
@@ -3259,8 +3274,8 @@
 
       //  -  The value of nuh_layer_id for the generated picture is set equal to nuh_layer_id.
-      genPic->setLayerId( nuhLayerId ); 
+      genPic->setLayerId( nuhLayerId );
 
       // Insert to DPB
-      m_dpb->addNewPic( genPic ); 
+      m_dpb->addNewPic( genPic );
     }
   }
@@ -3280,8 +3295,8 @@
   std::vector<TComPic*>** refPicSetsCurr       = m_pcPic->getDecodedRps()->m_refPicSetsCurr;
 
-  Bool hasGeneratedRefPic = false; 
-  for (Int j = 0; j < 3; j++ )   
-  {    
-    std::vector<TComPic*>* cSet = refPicSetsCurr[j]; 
+  Bool hasGeneratedRefPic = false;
+  for (Int j = 0; j < 3; j++ )
+  {
+    std::vector<TComPic*>* cSet = refPicSetsCurr[j];
     for (Int i = 0 ; i < cSet->size();  i++ )
     {
@@ -3289,9 +3304,9 @@
       if ((*cSet)[i]->getIsGenerated() )
       {
-        hasGeneratedRefPic = true; 
-      }
-    }
-  }
-  m_pcPic->setHasGeneratedRefPics( hasGeneratedRefPic ); 
+        hasGeneratedRefPic = true;
+      }
+    }
+  }
+  m_pcPic->setHasGeneratedRefPics( hasGeneratedRefPic );
 }
 
Index: /trunk/source/Lib/TLibEncoder/SEIEncoder.cpp
===================================================================
--- /trunk/source/Lib/TLibEncoder/SEIEncoder.cpp	(revision 1355)
+++ /trunk/source/Lib/TLibEncoder/SEIEncoder.cpp	(revision 1356)
@@ -465,4 +465,5 @@
 
 #if NH_MV
+#if !NH_MV_SEI
 Void SEIEncoder::initSEISubBitstreamProperty(SEISubBitstreamProperty *seiSubBitstreamProperty, const TComSPS *sps)
 {
@@ -476,5 +477,37 @@
   seiSubBitstreamProperty->m_maxBitRate              = m_pcCfg->getMaxBitRate();  
 }
+#else
+Void SEIEncoder::createAnnexFGISeiMessages( SEIMessages& seiMessage, const TComSlice* slice )
+{
+  const SEIMessages* seiMessageCfg = m_pcCfg->getSeiMessages(); 
+
+  for( SEIMessages::const_iterator itS = seiMessageCfg->begin(); itS != seiMessageCfg->end(); itS++ )    
+  {      
+    const SEI* curSei = (*itS); 
+    SEI* newSei; 
+    if ( curSei->insertSei( slice->getLayerId(), slice->getPOC(), slice->getTemporalId(), slice->getNalUnitType() ) )
+    {
+      newSei = curSei->getCopy( ) ;
+
+      if ( curSei->m_modifyByEncoder )
+      {
+        newSei->setupFromSlice  ( slice ); 
+      } 
+
+      if ( newSei   ->checkCfg( slice ) )
+      {
+        std::cout << "--> Omit sending SEI."  <<  std::endl; 
+        delete newSei; 
+      }
+      else
+      {
+        seiMessage.push_back(newSei); 
+      }
+
+    }
+  }
+}
 #endif
+#endif
 
 //! \}
Index: /trunk/source/Lib/TLibEncoder/SEIEncoder.h
===================================================================
--- /trunk/source/Lib/TLibEncoder/SEIEncoder.h	(revision 1355)
+++ /trunk/source/Lib/TLibEncoder/SEIEncoder.h	(revision 1356)
@@ -86,5 +86,9 @@
   Void initTemporalLevel0IndexSEI(SEITemporalLevel0Index *sei, TComSlice *slice);
 #if NH_MV
+#if !NH_MV_SEI
   Void initSEISubBitstreamProperty(SEISubBitstreamProperty *seiSubBitstreamProperty, const TComSPS *sps);
+#else
+  Void createAnnexFGISeiMessages( SEIMessages& seiMessage, const TComSlice* slice );;
+#endif
 #endif
 private:
Index: /trunk/source/Lib/TLibEncoder/SEIwrite.cpp
===================================================================
--- /trunk/source/Lib/TLibEncoder/SEIwrite.cpp	(revision 1355)
+++ /trunk/source/Lib/TLibEncoder/SEIwrite.cpp	(revision 1356)
@@ -122,8 +122,69 @@
     break;
 #if NH_MV
+#if !NH_MV_SEI
    case SEI::SUB_BITSTREAM_PROPERTY:
    xWriteSEISubBitstreamProperty(*static_cast<const SEISubBitstreamProperty*>(&sei));
    break;
 #endif
+#endif
+#if NH_MV_SEI
+#if NH_MV_LAYERS_NOT_PRESENT_SEI
+   case SEI::LAYERS_NOT_PRESENT:
+       xWriteSEILayersNotPresent(*static_cast<const SEILayersNotPresent*>(&sei));
+     break;
+#endif
+   case SEI::INTER_LAYER_CONSTRAINED_TILE_SETS:
+     xWriteSEIInterLayerConstrainedTileSets(*static_cast<const SEIInterLayerConstrainedTileSets*>(&sei));
+     break;
+#if NH_MV_SEI_TBD
+   case SEI::BSP_NESTING:
+     xWriteSEIBspNesting(*static_cast<const SEIBspNesting*>(&sei));
+     break;
+   case SEI::BSP_INITIAL_ARRIVAL_TIME:
+     xWriteSEIBspInitialArrivalTime(*static_cast<const SEIBspInitialArrivalTime*>(&sei));
+     break;
+#endif
+   case SEI::SUB_BITSTREAM_PROPERTY:
+     xWriteSEISubBitstreamProperty(*static_cast<const SEISubBitstreamProperty*>(&sei));
+     break;
+   case SEI::ALPHA_CHANNEL_INFO:
+     xWriteSEIAlphaChannelInfo(*static_cast<const SEIAlphaChannelInfo*>(&sei));
+     break;
+   case SEI::OVERLAY_INFO:
+     xWriteSEIOverlayInfo(*static_cast<const SEIOverlayInfo*>(&sei));
+     break;
+   case SEI::TEMPORAL_MV_PREDICTION_CONSTRAINTS:
+     xWriteSEITemporalMvPredictionConstraints(*static_cast<const SEITemporalMvPredictionConstraints*>(&sei));
+     break;
+#if NH_MV_SEI_TBD
+   case SEI::FRAME_FIELD_INFO:
+     xWriteSEIFrameFieldInfo(*static_cast<const SEIFrameFieldInfo*>(&sei));
+     break;
+#endif
+   case SEI::THREE_DIMENSIONAL_REFERENCE_DISPLAYS_INFO:
+     xWriteSEIThreeDimensionalReferenceDisplaysInfo(*static_cast<const SEIThreeDimensionalReferenceDisplaysInfo*>(&sei));
+     break;
+#if SEI_DRI_F0169
+   case SEI::DEPTH_REPRESENTATION_INFO:
+       xWriteSEIDepthRepresentationInfo(*static_cast<const SEIDepthRepresentationInfo*>(&sei));
+       break;
+#endif
+   case SEI::MULTIVIEW_SCENE_INFO:
+     xWriteSEIMultiviewSceneInfo(*static_cast<const SEIMultiviewSceneInfo*>(&sei));
+     break;
+   case SEI::MULTIVIEW_ACQUISITION_INFO:
+     xWriteSEIMultiviewAcquisitionInfo(*static_cast<const SEIMultiviewAcquisitionInfo*>(&sei));
+     break;
+
+   case SEI::MULTIVIEW_VIEW_POSITION:
+     xWriteSEIMultiviewViewPosition(*static_cast<const SEIMultiviewViewPosition*>(&sei));
+     break;
+#if NH_3D
+   case SEI::ALTERNATIVE_DEPTH_INFO:
+     xWriteSEIAlternativeDepthInfo(*static_cast<const SEIAlternativeDepthInfo*>(&sei));
+     break;
+#endif
+#endif
+
 
   default:
@@ -246,5 +307,5 @@
   for (Int i = 0; i < sei.activeSeqParameterSetId.size(); i++)
   {
-    WRITE_UVLC(sei.activeSeqParameterSetId[i], "active_seq_parameter_set_id"); 
+    WRITE_UVLC(sei.activeSeqParameterSetId[i], "active_seq_parameter_set_id");
   }
 }
@@ -384,5 +445,5 @@
 {
   WRITE_FLAG( sei.m_arrangementCancelFlag,          "segmented_rect_frame_packing_arrangement_cancel_flag" );
-  if( sei.m_arrangementCancelFlag == 0 ) 
+  if( sei.m_arrangementCancelFlag == 0 )
   {
     WRITE_CODE( sei.m_contentInterpretationType, 2, "segmented_rect_content_interpretation_type" );
@@ -553,5 +614,5 @@
 {
   //UInt code;
-  WRITE_FLAG((sei.m_mc_all_tiles_exact_sample_value_match_flag ? 1 : 0), "mc_all_tiles_exact_sample_value_match_flag"); 
+  WRITE_FLAG((sei.m_mc_all_tiles_exact_sample_value_match_flag ? 1 : 0), "mc_all_tiles_exact_sample_value_match_flag");
   WRITE_FLAG((sei.m_each_tile_one_tile_set_flag                ? 1 : 0), "each_tile_one_tile_set_flag"               );
 
@@ -568,19 +629,19 @@
 
         if(sei.m_limited_tile_set_display_flag)
-        { 
-          WRITE_FLAG((sei.tileSetData(i).m_display_tile_set_flag ? 1 : 0), "display_tile_set_flag");  
-        }
-
-        WRITE_UVLC((sei.tileSetData(i).getNumberOfTileRects() - 1), "num_tile_rects_in_set_minus1"); 
-        
+        {
+          WRITE_FLAG((sei.tileSetData(i).m_display_tile_set_flag ? 1 : 0), "display_tile_set_flag");
+        }
+
+        WRITE_UVLC((sei.tileSetData(i).getNumberOfTileRects() - 1), "num_tile_rects_in_set_minus1");
+
         for(Int j = 0; j < sei.tileSetData(i).getNumberOfTileRects(); j++)
         {
-          WRITE_UVLC(sei.tileSetData(i).topLeftTileIndex    (j), "top_left_tile_index");  
-          WRITE_UVLC(sei.tileSetData(i).bottomRightTileIndex(j), "bottom_right_tile_index");  
+          WRITE_UVLC(sei.tileSetData(i).topLeftTileIndex    (j), "top_left_tile_index");
+          WRITE_UVLC(sei.tileSetData(i).bottomRightTileIndex(j), "bottom_right_tile_index");
         }
 
         if(!sei.m_mc_all_tiles_exact_sample_value_match_flag)
         {
-          WRITE_FLAG((sei.tileSetData(i).m_exact_sample_value_match_flag ? 1 : 0), "exact_sample_value_match_flag");  
+          WRITE_FLAG((sei.tileSetData(i).m_exact_sample_value_match_flag ? 1 : 0), "exact_sample_value_match_flag");
         }
 
@@ -590,5 +651,5 @@
         {
           WRITE_FLAG((sei.tileSetData(i).m_mcts_tier_flag ? 1 : 0), "mcts_tier_flag");
-          WRITE_CODE( sei.tileSetData(i).m_mcts_level_idc, 8,       "mcts_level_idc"); 
+          WRITE_CODE( sei.tileSetData(i).m_mcts_level_idc, 8,       "mcts_level_idc");
         }
       }
@@ -601,6 +662,6 @@
     if(sei.m_max_mcs_tier_level_idc_present_flag)
     {
-      WRITE_FLAG((sei.m_max_mcts_tier_flag ? 1 : 0), "max_mcts_tier_flag");  
-      WRITE_CODE( sei.m_max_mcts_level_idc, 8,       "max_mcts_level_idc"); 
+      WRITE_FLAG((sei.m_max_mcts_tier_flag ? 1 : 0), "max_mcts_tier_flag");
+      WRITE_CODE( sei.m_max_mcts_level_idc, 8,       "max_mcts_level_idc");
     }
   }
@@ -702,5 +763,5 @@
   userVerticalCoefficients[2][2] = 100;
   userVerticalCoefficients[2][3] = -10;
-  
+
   Int const iNumHorizontalFilters = 1;
   Int horizontalTapLength_minus1[iNumHorizontalFilters] = {3};
@@ -748,4 +809,5 @@
 
 #if NH_MV
+#if !NH_MV_SEI
 Void SEIWriter::xWriteSEISubBitstreamProperty(const SEISubBitstreamProperty &sei)
 {
@@ -765,9 +827,10 @@
 }
 #endif
+#endif
 
 Void SEIWriter::xWriteSEIKneeFunctionInfo(const SEIKneeFunctionInfo &sei)
 {
   WRITE_UVLC( sei.m_kneeId, "knee_function_id" );
-  WRITE_FLAG( sei.m_kneeCancelFlag, "knee_function_cancel_flag" ); 
+  WRITE_FLAG( sei.m_kneeCancelFlag, "knee_function_cancel_flag" );
   if ( !sei.m_kneeCancelFlag )
   {
@@ -800,5 +863,5 @@
   WRITE_CODE( sei.values.whitePoint[0],    16,  "white_point_x" );
   WRITE_CODE( sei.values.whitePoint[1],    16,  "white_point_y" );
-    
+
   WRITE_CODE( sei.values.maxLuminance,     32,  "max_display_mastering_luminance" );
   WRITE_CODE( sei.values.minLuminance,     32,  "min_display_mastering_luminance" );
